unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, XPMan, StdCtrls, ComCtrls;

type
  TGame = (gAOK, gAOC);

  TMainForm = class(TForm)
    GroupBox1: TGroupBox;
    AOKRB: TRadioButton;
    AOCRB: TRadioButton;
    TrackBar: TTrackBar;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ValueLabel: TLabel;
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
    procedure AOKRBClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    Game: TGame;
    function GetRegValue: Integer;
    function SetRegValue(const AValue: Integer): Boolean;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
  Registry;

const
  DEFAULT_VALUE = 15;
  MSG = 'Registry has been successfuly updated.';

function TMainForm.GetRegValue: Integer;
var
  Registry: TRegistry;
  sPath: String;
begin
  Registry := TRegistry.Create(KEY_READ);
  try
    case Game of
      gAOK: sPath := '\Software\Microsoft\Microsoft Games\Age of Empires\2.0';
      gAOC: sPath := '\Software\Microsoft\Microsoft Games\Age of Empires II: The Conquerors Expansion\1.0';
    end;
    Registry.OpenKey(sPath, False);
    Result := Registry.ReadInteger('Game Speed');
  finally
    Registry.Free;
  end;
end;

function TMainForm.SetRegValue(const AValue: Integer): Boolean;
var
  Registry: TRegistry;
  sPath: String;
begin
  Registry := TRegistry.Create(KEY_WRITE);
  try
    case Game of
      gAOK: sPath := '\Software\Microsoft\Microsoft Games\Age of Empires\2.0';
      gAOC: sPath := '\Software\Microsoft\Microsoft Games\Age of Empires II: The Conquerors Expansion\1.0';
    end;
    Registry.OpenKey(sPath, False);
    Registry.WriteInteger('Game Speed', AValue);
    Result := True;
  finally
    Registry.Free;
  end;
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Caption := Application.Title;
  Game := gAOK;
  TrackBar.Position := DEFAULT_VALUE;
  TrackBar.Position := GetRegValue;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  if SetRegValue(DEFAULT_VALUE) then
  begin
    TrackBar.Position := DEFAULT_VALUE;
    MessageDlg(MSG, mtInformation, [mbOK], 0);
  end;
end;

procedure TMainForm.TrackBarChange(Sender: TObject);
begin
  ValueLabel.Caption := IntToStr(TrackBar.Position);
end;

procedure TMainForm.AOKRBClick(Sender: TObject);
begin
  if (Sender = AOKRB) then
    Game := gAOK
  else if (Sender = AOCRB) then
    Game := gAOC;
  TrackBar.Position := GetRegValue;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  if SetRegValue(TrackBar.Position) then
    MessageDlg(MSG, mtInformation, [mbOK], 0);
end;

end.
